#!/usr/bin/python

import sqlite3
import sys
import os

scratch_paths = {"scratch_local":"scratch", "scratch_ssd":"scratch.ssd", "scratch_shared": "scratch.shared"}

def get_used(scratch_type):
    sqlite_db="/var/spool/pbs/resources.db"
    conn = sqlite3.connect(sqlite_db)
    c = conn.cursor()
    
    c.execute("SELECT name FROM sqlite_master WHERE type='table' AND name='resources'");
    if c.fetchone() == None:
        return 0

    #for row in c.execute("SELECT * FROM resources"):
    #    print row

    c.execute("SELECT SUM(value) FROM resources WHERE resource_type='%s'" % scratch_type)
    result = c.fetchone()[0]
    conn.close()

    if result:
        return result
    else:
        return 0

def get_avail(scratch_type):
    global scratch_paths

    try:
        s = os.statvfs("/%s/" % scratch_paths[scratch_type])
        return s.f_bsize * s.f_bavail /1024
    except:
        return 0
    
    
if len(sys.argv) < 2:
    scratch_type = "scratch_local"
elif sys.argv[1] in scratch_paths.keys():
    scratch_type = sys.argv[1]
else:
    scratch_type = "scratch_local"

used = get_used(scratch_type)
avail = get_avail(scratch_type)

print max(0, avail - used)

